=begin
#DocuSign Admin API

#An API for an organization administrator to manage organizations, accounts and users

OpenAPI spec version: v2.1
Contact: devcenter@docusign.com
Generated by: https://github.com/swagger-api/swagger-codegen.git

=end

require 'date'

module DocuSign_Admin
  class OrganizationAccountSettingsImportResponse
    attr_accessor :created

    attr_accessor :last_modified

    attr_accessor :completed

    attr_accessor :expires

    attr_accessor :percent_completed

    attr_accessor :number_processed_accounts

    attr_accessor :number_unprocessed_accounts

    attr_accessor :results

    attr_accessor :success

    attr_accessor :skipped_settings_by_account

    attr_accessor :id

    attr_accessor :organization_id

    attr_accessor :status

    attr_accessor :type

    attr_accessor :requestor

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'created' => :'created',
        :'last_modified' => :'last_modified',
        :'completed' => :'completed',
        :'expires' => :'expires',
        :'percent_completed' => :'percent_completed',
        :'number_processed_accounts' => :'number_processed_accounts',
        :'number_unprocessed_accounts' => :'number_unprocessed_accounts',
        :'results' => :'results',
        :'success' => :'success',
        :'skipped_settings_by_account' => :'skipped_settings_by_account',
        :'id' => :'id',
        :'organization_id' => :'organization_id',
        :'status' => :'status',
        :'type' => :'type',
        :'requestor' => :'requestor'
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      {
        :'created' => :'DateTime',
        :'last_modified' => :'DateTime',
        :'completed' => :'DateTime',
        :'expires' => :'DateTime',
        :'percent_completed' => :'Integer',
        :'number_processed_accounts' => :'Integer',
        :'number_unprocessed_accounts' => :'Integer',
        :'results' => :'Array<OrganizationAccountSettingsImportResultResponse>',
        :'success' => :'BOOLEAN',
        :'skipped_settings_by_account' => :'Hash<String, Array<String>>',
        :'id' => :'String',
        :'organization_id' => :'String',
        :'status' => :'String',
        :'type' => :'String',
        :'requestor' => :'OrganizationAccountSettingsImportRequestorResponse'
      }
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h| h[k.to_sym] = v }

      if attributes.has_key?(:'created')
        self.created = attributes[:'created']
      end

      if attributes.has_key?(:'last_modified')
        self.last_modified = attributes[:'last_modified']
      end

      if attributes.has_key?(:'completed')
        self.completed = attributes[:'completed']
      end

      if attributes.has_key?(:'expires')
        self.expires = attributes[:'expires']
      end

      if attributes.has_key?(:'percent_completed')
        self.percent_completed = attributes[:'percent_completed']
      end

      if attributes.has_key?(:'number_processed_accounts')
        self.number_processed_accounts = attributes[:'number_processed_accounts']
      end

      if attributes.has_key?(:'number_unprocessed_accounts')
        self.number_unprocessed_accounts = attributes[:'number_unprocessed_accounts']
      end

      if attributes.has_key?(:'results')
        if (value = attributes[:'results']).is_a?(Array)
          self.results = value
        end
      end

      if attributes.has_key?(:'success')
        self.success = attributes[:'success']
      end

      if attributes.has_key?(:'skipped_settings_by_account')
        if (value = attributes[:'skipped_settings_by_account']).is_a?(Hash)
          self.skipped_settings_by_account = value
        end
      end

      if attributes.has_key?(:'id')
        self.id = attributes[:'id']
      end

      if attributes.has_key?(:'organization_id')
        self.organization_id = attributes[:'organization_id']
      end

      if attributes.has_key?(:'status')
        self.status = attributes[:'status']
      end

      if attributes.has_key?(:'type')
        self.type = attributes[:'type']
      end

      if attributes.has_key?(:'requestor')
        self.requestor = attributes[:'requestor']
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      true
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          created == o.created &&
          last_modified == o.last_modified &&
          completed == o.completed &&
          expires == o.expires &&
          percent_completed == o.percent_completed &&
          number_processed_accounts == o.number_processed_accounts &&
          number_unprocessed_accounts == o.number_unprocessed_accounts &&
          results == o.results &&
          success == o.success &&
          skipped_settings_by_account == o.skipped_settings_by_account &&
          id == o.id &&
          organization_id == o.organization_id &&
          status == o.status &&
          type == o.type &&
          requestor == o.requestor
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [created, last_modified, completed, expires, percent_completed, number_processed_accounts, number_unprocessed_accounts, results, success, skipped_settings_by_account, id, organization_id, status, type, requestor].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.swagger_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :BOOLEAN
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        temp_model = DocuSign_Admin.const_get(type).new
        temp_model.build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end

  end
end
